package cn.estsh.i3plus.pojo.platform.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.List;

/**
 * @Description : 用户登陆表
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-10-11 11:02
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@Table(name="sys_user")
@Api(value="用户登陆表",description = "用户登陆系统账户。")
public class SysUser extends BaseBean {

    private static final long serialVersionUID = 1L;

    @Column(name="NAME")
    @ApiParam(value ="名称" , access ="名称")
    private String name;

    @Column(name="USER_LOGIN_NAME")
    @ApiParam(value ="登陆名称" , access ="登陆名称")
    private String userLoginName;

    @Column(name="USER_EMP_NO")
    @ApiParam(value ="工号")
    private String userEmpNo;

    @Column(name="USER_LOGIN_PASSWORD")
    @ApiParam(value ="登陆密码")
    private String userLoginPassword;

    @Column(name="USER_TYPE_ID")
    @ApiParam(value ="用户类型（枚举，待定）" , example ="-1")
    private Integer userTypeId;

    @Column(name="DEPARTMENT_ID")
    @ApiParam(value ="部门ID" , example ="-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long departmentId;

    public Long getDepartmentId() {
        if(departmentId != null) {
            return departmentId.longValue();
        }else{
            return departmentId;
        }
    }

    @Column(name="POSITION_ID")
    @ApiParam(value ="岗位ID" , example ="-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long positionId;

    public Long getPositionId() {
        if(positionId != null) {
            return positionId.longValue();
        }else{
            return positionId;
        }
    }

    @Column(name="ROLE_ID")
    @ApiParam(value ="角色ID" , example ="-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long roleId;

    public Long getRoleId() {
        if(roleId != null) {
            return roleId.longValue();
        }else{
            return roleId;
        }
    }

    @Column(name="ORGANIZE_ID")
    @ApiParam(value ="组织ID" , example = "0")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long organizeId;

    public Long getOrganizeId() {
        if(organizeId != null) {
            return organizeId.longValue();
        }else{
            return organizeId;
        }
    }

    @Column(name="RED_ROLE_NAME")
    @ApiParam(value ="角色名称" , access ="角色名称")
    private String redRoleName;

    @Column(name="RED_POSITION_NAME")
    @ApiParam(value ="岗位名称" , access ="岗位名称")
    private String redPositionName;

    @Column(name="RED_DEPARTMENT_NAME")
    @ApiParam(value ="部门名称" , access ="部门名称")
    private String redDepartmentName;

    @Column(name="RED_ORGANIZE_NAME")
    @ApiParam(value ="组织名称" , access ="组织名称")
    private String redOrganizeName;

    @Column(name="USER_ONLINE_ID")
    @ApiParam(value ="是否在线(枚举：1.在线，2.离线)" , example ="-1")
    private Integer userOnlineId;

    @Column(name="USER_EMAIL")
    @ApiParam(value ="邮箱" , access ="邮箱")
    private String userEmail;

    @Column(name="USER_PHONE")
    @ApiParam(value ="手机号" , access ="手机号")
    private String userPhone;

    @Column(name="USER_STATUS_ID")
    @ApiParam(value ="用户状态(枚举：1正常,2冻结使用,3账号异常,4离职，5服务到期)" , example ="-1")
    private Integer userStatusId;

    @Column(name="USER_LOGIN_LAST_DATE_TIME")
    @ApiParam(value ="用户最后登录时间")
    private String userLoginLastDateTime;

    @ApiParam(value ="用户详细信息")
    private transient SysUserInfo userInfo;

    @ApiParam(value ="用户所有角色信息")
    private transient List<SysRole> roleList;

    @ApiParam(value ="用户所有权限信息")
    private transient List<SysMenu> menuList;

    @ApiParam(value ="用户所有部门信息")
    private transient List<Department> departmentList;

    @ApiParam(value ="用户所有岗位信息")
    private transient List<Position> positionList;

    @ApiParam(value ="用户组织信息")
    private transient Organize organize;

}
